/*
		JumpToMob.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class for dialog of same name
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "JumpToMob.h"
#include "medit.h"
#include "mob.h"
#include "World.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JumpToMob dialog


JumpToMob::JumpToMob(CWnd* pParent /*=NULL*/)
	: CDialog(JumpToMob::IDD, pParent)
{
	//{{AFX_DATA_INIT(JumpToMob)
	m_jump_string = _T("");
	m_new_mob = 0;
	//}}AFX_DATA_INIT
}


void JumpToMob::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JumpToMob)
	DDX_Text(pDX, IDC_JUMP_WARNING, m_jump_string);
	DDX_Text(pDX, IDC_NEW_MOB, m_new_mob);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JumpToMob, CDialog)
	//{{AFX_MSG_MAP(JumpToMob)
	ON_EN_CHANGE(IDC_NEW_MOB, OnChangeNewMob)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JumpToMob message handlers

extern World the_world;

void JumpToMob::OnOK() 
{
  extern CCbreakApp theApp;
  map<int,Mob>::const_iterator ri;

	if(m_new_mob > 32699 || m_new_mob < 0) {
	  m_jump_string = "Out of Range";
		UpdateData(FALSE);
		return;
	}

	ri = the_world.mob_list.find(m_new_mob);
	if(ri==the_world.mob_list.end()) {
		m_jump_string = "That mob DNE";
		UpdateData(FALSE);
		return;
	}

	theApp.dlg->current_mob = m_new_mob;
	
	theApp.dlg->m_medit.LoadMedit();

	CDialog::OnOK();
}

void JumpToMob::OnChangeNewMob() 
{
	  UpdateData();	
}

BOOL JumpToMob::OnInitDialog() 
{
	CDialog::OnInitDialog();
    GetDlgItem(IDC_NEW_MOB)->SetFocus();
	
	return TRUE;  
}
